#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/Scale.h>
#include <Xm/List.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>
#include <Xm/SelectioB.h>
#include <Xm/FileSB.h>
#include <Mrm/MrmPublic.h>

#ifdef __GNUG__
#pragma implementation "yoo_widget.hxx"
#endif

#include "yoo_widget.hxx"

const char* const SEP_POINT = "." ;
const int SEP_POINT_LEN = 1 ;
YooWidget* YOO_WidgetControl ;

YooWidget::YooWidget(XtAppContext app, Widget w) {
  _app_context= app ;
  _w_racine= w ;
  _name_i= 0 ;
  for (int i=0; (i<_name_max) ; i++) {
    _name[i].name= NULL ;
    _name[i].value= NULL ;
  }
} ;

int
YooWidget::register_name(char *name, XtPointer proc) {
  for (int i=0 ; (i < _name_i) ; i++)
    if (strcmp(name,_name[i].name)==0) break ;
  // Dans tous les cas i designe l'indice ou il faut ecrire
  if (i < _name_max) {
    // tous les noms ont ete alloues localement
    if ( _name[i].name != NULL)  free(_name[i].name) ;
    _name[i].name= strdup(name) ;
    _name[i].value= proc ;
    _name_i++ ;
    return 0 ;
  } else {
    return -1 ;
  }
}

void
YooWidget::register_name(MrmRegisterArg t[], int t_count) {
  for (int i=0; (i < _name_max) && (i < t_count); i++) {
    // tous les noms ont ete alloues localement
    if ( _name[i].name != NULL) free(_name[i].name) ;
    _name[i].name= strdup(t[i].name) ;
    _name[i].value= t[i].value ;
  }
  _name_i= i ;
}

int 
YooWidget::exist(char* nhp) {
  
  Widget w ;

  if ( (w= XtNameToWidget(_w_racine,nhp)) == NULL ) {
    return (_error_wc= WIDGET_CONTROL_OK, 0) ;
  }

  return (_error_wc= WIDGET_CONTROL_OK, 1) ;
}

int 
YooWidget::show(char* nhp) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }

  if (XtIsShell(w)) 
    XtPopup(w,XtGrabNone) ;
  else
    XtManageChild(w) ;

  return  (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::hide(char* nhp) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  if (XtIsShell(w)) 
    XtPopdown(w) ;
  else
    XtUnmanageChild(w) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::enable(char* nhp) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  XtSetSensitive(w,True) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::disable(char* nhp) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  XtSetSensitive(w,False) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::set_text(char* nhp,char* text) {
  
  Widget w ;
  
  w= XtNameToWidget(_w_racine,nhp) ;
  return set_text(w,text) ;
}

int 
YooWidget::set_text(Widget w,char* text) {
  
  int mode_edit ;
  
  if ( w == NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }

  if (XmIsLabel(w)) {
    XmString t_xmstring ;
    t_xmstring= XmStringCreateSimple(text) ;
    XtVaSetValues(w,XmNlabelString,t_xmstring,XmNlabelType,XmSTRING,NULL) ;
    // ------------- peut-etre doit-on liberer t_xmstring ?
  }else if (XmIsSelectionBox(w) || XmIsFileSelectionBox(w)) {
    XmString t_xmstring ;
    t_xmstring= XmStringCreateSimple(text) ;
    XtVaSetValues(w,XmNtextString,t_xmstring,NULL) ;
    // ------------- peut-etre doit-on liberer t_xmstring ?
  } else if (XmIsTextField(w)) {
    XmTextFieldSetString(w,text) ;
  } else if (XmIsText(w)) {
    XtVaGetValues(w,XmNeditMode,&mode_edit,NULL) ;
    if (mode_edit == XmSINGLE_LINE_EDIT) {
      XmTextSetString(w,text) ;
    } else {
      XmTextPosition pos1=0, pos2=0 ;

      pos1= XmTextGetLastPosition(w) ;
      XmTextInsert(w,pos1,text) ;
      pos2= XmTextGetLastPosition(w) ;
      XmTextInsert(w,pos2,"\n") ;

      XmTextShowPosition(w,pos1) ;
    }
  } else {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }


  return (_error_wc= WIDGET_CONTROL_OK) ;
}

char *
YooWidget::get_text(char* nhp) {
  
  Widget w ;
 
  w= XtNameToWidget(_w_racine,nhp) ;
  return get_text(w) ;
}

char *
YooWidget::get_text(Widget w) {
  
  char *text= NULL ;
  unsigned char label_type ;
  
  if ( w == NULL) {
    return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
  }
  
  if (XmIsLabel(w)) {
    XtVaGetValues(w,XmNlabelType,&label_type,NULL) ;
    if (label_type == XmSTRING) {
      XmString t_xmstring ;
      int status ;
      
      XtVaGetValues(w,XmNlabelString,&t_xmstring,NULL) ;
      if ( ! (status= XmStringGetLtoR(t_xmstring,
				      XmSTRING_DEFAULT_CHARSET,
				      &text)) ) {
	return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
      }
    } else {
      return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
    }
  } else if (XmIsSelectionBox(w) || XmIsFileSelectionBox(w)) {
    XmString t_xmstring ;
    int status ;
    
    XtVaGetValues(w,XmNtextString,&t_xmstring,NULL) ;
    if ( ! (status= XmStringGetLtoR(t_xmstring,
				    XmSTRING_DEFAULT_CHARSET,
				    &text)) ) {
      return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
    }

  } else if (XmIsTextField(w)) {
    text= XmTextFieldGetString(w) ;
  }
  else if (XmIsText(w)) {
    text= XmTextGetString(w) ;
  } else {
    return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
  }

  return (_error_wc= WIDGET_CONTROL_OK, text) ;
}


int 
YooWidget::set_scale_value(char* nhp,int value) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  XmScaleSetValue(w,value) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::get_scale_value(char* nhp) {
  
  Widget w ;
  int value=0 ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO, 0) ;
  }
  
  XmScaleGetValue(w,&value) ;

  return (_error_wc= WIDGET_CONTROL_OK, value) ;
}

int 
YooWidget::set_choice_text(char* nhp, const ListVal<char*>& l_item) {
  
  Widget w ;
  XmString *t_xmstring ;
  int t_size ;
  int i ;
 
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  if ( ! XmIsList(w) ) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  // Construction d'une table de XmString a partir de la liste d'item
  t_size= l_item.count() ;
  t_xmstring= (XmString *) malloc( sizeof(XmString) * t_size) ;

  IterListVal<char*>  p(l_item) ;
  
  for ( i=0 ; (p.more() && i<t_size) ; p.next(),i++ )
    t_xmstring[i]= XmStringCreateSimple(p.get()) ;

  XmListDeleteAllItems(w) ;
  XmListAddItems(w,t_xmstring,t_size,1) ;

  for (i=0 ; i<t_size ; i++) 
    XmStringFree(t_xmstring[i]) ;
  free(t_xmstring) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::set_choice_selection(char* nhp, const ListVal<int>& l_sel) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
    
  XmListDeselectAllItems(w) ;
  for ( IterListVal<int>  p(l_sel) ; p.more() ; p.next() ) 
    XmListSelectPos(w,(p.get() + 1),True) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}


ListVal<char*>
YooWidget::get_choice_text(char* nhp) {
  
  Widget w ;
  ListVal<char*> l_item ;
  
  XmStringTable t_xmstring ;
  int t_size ;
  char *p_text ;
  int i, status ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO, l_item) ;
  }

  // Obtenir les item
  XtVaGetValues(w,
		XmNitemCount, &t_size,
		XmNitems,     &t_xmstring,
		NULL) ;

  // Insertion dans la liste
  for (i=0 ; i<t_size ; i++) {
    status= XmStringGetLtoR(t_xmstring[i],
			    XmSTRING_DEFAULT_CHARSET,
			    &p_text) ;
    if (status==True)
      l_item.insert(p_text,-1) ;
  }

  _error_wc= WIDGET_CONTROL_OK ;
  return ListVal<char*>(l_item ,YOOC_LIST_CTOR) ;
}

ListVal<int>
YooWidget::get_choice_selection(char* nhp) {
  
  Widget w ;
  ListVal<int> l_sel ;
  
  int t_size ;
  int *t_sel ;
  int i ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    _error_wc= WIDGET_CONTROL_KO ;
    return( ListVal<int>(l_sel ,YOOC_LIST_CTOR) ) ;
  }
  
  if (XmListGetSelectedPos(w,&t_sel,&t_size) != True) {
    // cf. Motif Programming Manual 6A page 422
    // retourne False si aucun item n'est selectionne ou si probleme !
    t_size= 0 ;
  }
  
  for (i=0 ; i< t_size ; i++) {
    l_sel.insert((t_sel[i]-1),-1) ;
  }
  
  _error_wc= WIDGET_CONTROL_OK ;
  return( ListVal<int>(l_sel ,YOOC_LIST_CTOR) ) ;
}


int 
YooWidget::set_state(char* nhp,int state) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  XmToggleButtonSetState(w,state,True) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;
}

int 
YooWidget::get_state(char* nhp) {
  
  Widget w ;
  int state=0 ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO, 0) ;
  }
  
  state= (XmToggleButtonGetState(w)) ? 1 : 0 ;

  return (_error_wc= WIDGET_CONTROL_OK, state) ;
}


int
YooWidget::fetch(char* nhp_pere,
		   char* n_fetch,char* n_modele,char* fichier_uid) {
  Cardinal status ;
  MrmType class_code ;
  Widget w_pere, w_fetch ;
  MrmHierarchy	hierarchy_id = NULL;
  
  if ( (w_pere= XtNameToWidget(_w_racine,nhp_pere)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }

  status = MrmOpenHierarchy(1, &fichier_uid, NULL, &hierarchy_id) ;
  if (status != MrmSUCCESS) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  // (contournement bug compilateur ?)--------------v
  status = MrmRegisterNamesInHierarchy(hierarchy_id,&(_name[0]),_name_i);
  if (status != MrmSUCCESS) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }

  w_fetch= NULL ;
  status=MrmFetchWidgetOverride(hierarchy_id,n_modele,w_pere,n_fetch,
				NULL,0,&w_fetch,&class_code) ;
  if (status!= MrmSUCCESS) {
    MrmCloseHierarchy(hierarchy_id);
    return (_error_wc= WIDGET_CONTROL_KO) ;
   }
  
  MrmCloseHierarchy(hierarchy_id) ;
  
  XtManageChild(w_fetch) ;
  XtRealizeWidget(w_fetch) ;
  
  return (_error_wc= WIDGET_CONTROL_OK) ;

}

int
YooWidget::fetch_toplevel(char* titre,
			    char* n_top,char* n_modele,char* fichier_uid) {
  Cardinal status ;
  MrmType class_code ;
  Widget w_top, w_fetch ;
  MrmHierarchy	hierarchy_id = NULL;

  status = MrmOpenHierarchy(1, &fichier_uid, NULL, &hierarchy_id) ;
  if (status != MrmSUCCESS) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  // (contournement bug compilateur ?)--------------v
  status = MrmRegisterNamesInHierarchy(hierarchy_id,&(_name[0]),_name_i);
  if (status != MrmSUCCESS) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }
  
  if (titre!=NULL) {
    w_top = XtVaCreatePopupShell( n_top,
				  topLevelShellWidgetClass, _w_racine,
				  XmNtitle, titre,
				  XmNiconName, titre,
				  NULL ) ;
  } else {
    w_top = XtVaCreatePopupShell( n_top,
				  topLevelShellWidgetClass, _w_racine,
				  NULL ) ;
  }
  if (w_top ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }

  w_fetch= NULL ;
  status=MrmFetchWidget(hierarchy_id,n_modele,w_top,&w_fetch,&class_code) ;
  if (status!= MrmSUCCESS) {
    MrmCloseHierarchy(hierarchy_id);
    return (_error_wc= WIDGET_CONTROL_KO) ;
   }
  
  MrmCloseHierarchy(hierarchy_id) ;
  
  XtManageChild(w_fetch) ;
  XtRealizeWidget(w_top) ;
  XtPopup(w_top,XtGrabNone) ;

  return (_error_wc= WIDGET_CONTROL_OK) ;

}

char*
YooWidget::get_name(char* nhp) {
  
  Widget w ;
  const int max_buffer1=1024 ;
  char buffer1[max_buffer1] ;
  int i_buffer1=0 ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
  }

  _widgetName(w,buffer1,i_buffer1,max_buffer1) ;
  
  if (i_buffer1 > 0 ) 
    return (_error_wc= WIDGET_CONTROL_OK, strdup(buffer1)) ;
  else
    return (_error_wc= WIDGET_CONTROL_KO, (char *) NULL) ;
}

int
YooWidget::destroy(char* nhp) {
  
  Widget w ;
  
  if ( (w= XtNameToWidget(_w_racine,nhp)) ==NULL) {
    return (_error_wc= WIDGET_CONTROL_KO) ;
  }

  XtDestroyWidget(w) ;
  
  return (_error_wc= WIDGET_CONTROL_OK) ;
}


void
YooWidget::_widgetName(Widget w,
		       char* cn_name,
		       int& cn_name_pos,
		       int cn_len) {
  
  // - calcule le nom hierarchiques complet d'un widget.
  // - cn_name est alloue par l'appelant.

  if (w == NULL) {
    cn_name_pos= 0 ;
    cn_name[cn_name_pos]= (char) 0 ;
    return ;
  }
  
  if (XtIsApplicationShell(w)) {
    cn_name_pos= 0 ;
    cn_name[cn_name_pos]= (char) 0 ;
  } else {
    // appel recursif, ecriture des noms des parents
    _widgetName(XtParent(w),cn_name,cn_name_pos,cn_len) ;
    {
      char *pn= XtName(w) ;
      if ((pn!=NULL) &&
	  ((cn_name_pos + SEP_POINT_LEN + strlen(pn)) < cn_len)) {
	strcpy(&(cn_name[cn_name_pos]),SEP_POINT) ;
	strcpy(&(cn_name[cn_name_pos + SEP_POINT_LEN]),pn) ;
	cn_name_pos += (SEP_POINT_LEN + strlen(pn)) ;
      }
    }
  }
}
